<template>
  <GenericLayout>
    <template #header>
      <Header
        :back-button="true"
        :title="pageTitle"
      />
    </template>

    <template
      #page-content
    >
      <div class="full-height column">
        <template v-if="isDesktopPlatform">
          <div
            class="page-title"
            v-if="pageTitle"
          >
            {{ pageTitle }}
          </div>
          <div
            class="page-subtitle"
            v-if="pageSubTitle"
          >
            {{ pageSubTitle }}
          </div>
        </template>

        <q-card
          :square="!isDesktopPlatform"
          class="column no-wrap col"
        >
          <q-banner
            class="bg-grey-3 text-grey-8"
          >
            <translate>The following parameters are used to compute the nutrients provided by the organic manure.</translate>
          </q-banner>

          <q-card-section>
            <div class="text-grey-8 q-mb-xs">
              <translate>Organic manure applications in the past campaigns</translate>
            </div>
            <q-select
              v-model="storeOrganicManureFrequency"
              :options="organicManureApplicationFrequencyOptions"
              option-value="id"
              :option-label="getRequafertiI18NFieldName('frequence')"
              filled
              :loading="isLoading"
              :label="$gettext('Frequency')"
            />
          </q-card-section>

          <q-card-section class="q-pb-none">
            <div class="text-grey-8 q-mb-xs">
              <translate>Organic manure applications in the current campaign</translate>
              <div class="text-small text-secondary">
                <translate>Number of applications:</translate> <span class="q-ml-xs">{{ organicManureApplicationCount }} / 3</span>
              </div>
            </div>
          </q-card-section>

          <RequafertiOrganicManureApplicationsCard
            :initial-organic-manure-applications="initialOrganicManureApplications"
            :organic-manure-animal-category-options="organicManureAnimalCategoryOptions"
            :organic-manure-application-combinations="organicManureApplicationCombinations"
            @on-update="onOrganicManureApplicationsUpdate"
          />

          <!-- buttons -->
          <q-card-section class="q-mt-auto">
            <q-card-actions
              class="q-pa-none"
              vertical
              align="stretch"
            >
              <q-btn
                color="primary"
                text-color="white"
                :disable="!canContinue"
                @click="onClickNext"
              >
                <translate>Compute</translate>
              </q-btn>
              <q-btn
                flat
                color="primary"
                @click="onClickPrevious"
              >
                <translate>Previous</translate>
              </q-btn>
            </q-card-actions>
          </q-card-section>
        </q-card>
      </div>
    </template>

    <template #footer>
      <Footer />
    </template>
  </GenericLayout>
</template>

<script>
import { PlatformMixin } from 'src/mixins/PlatformMixin'
import GenericLayout from 'src/layouts/GenericLayout'
import Header from 'src/components/layouts/Header'
import Footer from 'src/components/layouts/Footer'
import AlgorithmsMixins from 'src/pages/fieldbook/fertilization/algorithms/common/mixins/AlgorithmsMixins'
import RequafertiI18nMixin from 'src/pages/fieldbook/fertilization/algorithms/requaferti/mixins/RequafertiI18nMixin'
import RequafertiOrganicManureApplicationsCard from 'src/pages/fieldbook/fertilization/algorithms/requaferti/components/RequafertiOrganicManureApplicationsCard'
import queryRequafertiConfig from 'src/pages/fieldbook/fertilization/algorithms/requaferti/graphql/queryRequafertiConfig'

export default {
  name: 'RequafertiOrganicManurePage',
  components: {
    GenericLayout,
    Header,
    Footer,
    RequafertiOrganicManureApplicationsCard
  },
  mixins: [PlatformMixin, AlgorithmsMixins, RequafertiI18nMixin],
  data () {
    return {
      requafertiConfig: null
    }
  },
  computed: {
    pageTitle () {
      return this.$gettext('Organic manure')
    },
    pageSubTitle () {
      return 'Requaferti'
    },
    canContinue () {
      return this.isParameterSet(this.storeOrganicManureFrequency)
    },
    isLoading () {
      return !this.requafertiConfig
    },
    organicManureApplicationFrequencyOptions () {
      /* eslint-disable dot-notation */
      return this.requafertiConfig?.['freq_apport'] || []
    },
    organicManureAnimalCategoryOptions () {
      /* eslint-disable dot-notation */
      const amimalCategoryOptions = this.requafertiConfig?.['groupe_cat_animal'] || []

      // remove animal categories not having organic matter types
      return amimalCategoryOptions.filter(category => {
        return this.organicManureApplicationCombinations.filter(row => row.grp_ani_xid === category.id).length > 0
      })
    },
    organicManureApplicationCombinations () {
      /* eslint-disable dot-notation */
      return this.requafertiConfig?.['teneur_n'] || []
    },
    storeOrganicManureFrequency: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.organicManureFrequency
      },
      set (v) {
        this.updateParameter('organicManureFrequency', v)
      }
    },
    storeOrganicManureApplications: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.organicManureApplications || []
      },
      set (v) {
        this.updateParameter('organicManureApplications', v)
      }
    },
    organicManureApplicationCount () {
      return this.storeOrganicManureApplications?.length || 0
    },
    initialOrganicManureApplications () {
      // return a copy of the store as we handle updates in the method onOrganicManureApplicationsUpdate
      return this.storeOrganicManureApplications.map(storeOrganicManureApplication => ({ ...storeOrganicManureApplication }))
    }
  },
  async mounted () {
    // Load data from cache (or online if not in cache)
    await this.loadConfig('cache-first')

    // Refresh online data (do not wait until completion)
    this.loadConfig('network-only')
  },
  methods: {
    onClickNext () {
      this.$router.replace({
        name: 'requafertiCompute'
      })
    },
    onClickPrevious () {
      this.$router.replace({
        name: 'requafertiMeadowAndLucerne'
      })
    },
    onOrganicManureApplicationsUpdate (organicManureApplications) {
      this.storeOrganicManureApplications = [...organicManureApplications]
    },
    async loadConfig (fetchPolicy) {
      const { data } = await this.$apollo.query({
        query: queryRequafertiConfig,
        fetchPolicy
      })
      this.requafertiConfig = data?.requaferti__config
    }
  }
}
</script>
